<html>
<head>
<title>RManNotes: Stochastic Patterns: Perturbed Patterns</title>
</head>

<body bgcolor="#f9f9b1" background="notepad.gif" link="801010" vlink="101080" alink="108010"> <img alt="RManNotes" align=center src="header.gif">

<img align=center hspace=10 src="stoch_patterns.gif">

<p><img src="black_line.gif"></p>
<p>
<a href="pure.html">previous</a>
|
<a href="bombing.html">next</a>
|
<a href="index.html">stochastic patterns: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>
<p><img src="black_line.gif"></p>

<h1>Perturbed Regular Patterns</h1>

<p>
Often, irregular shapes can be made by adding irregularities to 
<a href="../RegularPatterns/index.html">regular patterns</a>
to make them less mechanical, more interesting, and more realistic
(and sometimes unrealistic). This kind of perturbation is achieved by
adding pseudo-random values to otherwise constant or regularly 
varying variables which control the shapes in the regular pattern. 
The random values are generated using <a href="noise.html">noise</a> with the 
current surface point or texture coordinates as inputs. 
Noise can be added to any component of the regular pattern including
(but not excluded to)
<ul>
<li><a href="../RegularPatterns/mod.html#sstt">texture coordinates</a>,
<li><a href="../RegularPatterns/txtr_coords.html#rotate2d">rotation angle</a>,
<li><a href="../RegularPatterns/shapes.html">distance calculations</a>; or
<li>colors and color spline indices.
</ul>
</p>

<h2>Randomized Rings</h2>

<p>
To perturb the "rings" shader, we just add a little bit of noise to
the texture coordinates and then apply the regular ring pattern
using the perturbed <code>ss</code> and <code>tt</code>. <code>noifreq</code>
affects the frequency of the perturbation, <code>noiscale</code> affects
the amount of perturbation.
</p>

<pre>
noi = noise(s * noifreq, t * noifreq);

ss = s + snoise(noi + 912) * noiscale;
tt = t + snoise(noi + 333) * noiscale;
</pre>

<p align=center><img hspace=25 src="rings.gif"><img src="rrings.gif">
<br>regular ring pattern (<a href="rings.sl">rings.sl</a>) and
perturbed ring pattern (<a href="rrings.sl">rrings.sl</a>)
</p>

<h2>Wood Solid Texture</h2>

<p>
The wood shader from <a href="../references.html">[Upstill90]</a> 
is achieved by perturbing a solid texture consisting of regular,
concentric cylinders. Noise is used twice in <a href="wood.sl">wood.sl</a>
1) to vary the shape of the rings by adding noise to <code><b>P</b></code>
and 2) to vary the width of the rings by adding noise to the 
computed distance from the central axis.
</p>

<p align=center>
<a href="notwood.256.jpg"><img hspace=25 src="notwood.128.gif"></a>
<a href="wood.256.jpg"><img src="wood.128.gif"></a>
<br>wood without perturbation (<a href="notwood.sl">notwood.sl</a>) and
the wood shader with perturbation (<a href="wood.sl">wood.sl</a>)
</p>

<p><img src="black_line.gif"></p>
<p>
<a href="pure.html">previous</a>
|
<a href="bombing.html">next</a>
|
<a href="index.html">stochastic patterns: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>

<p><img src="black_line.gif"></p> <small> <p><i>RManNotes</i> is Copyright &copy; 1995, 1996 Stephen F. May</p> <p> <i>Any comments or suggestions appreciated.</i> <address><a href="http://www.cgrg.ohio-state.edu/~smay">Steve May</a> (<a href="mailto:smay@cgrg.ohio-state.edu">smay@cgrg.ohio-state.edu</a>)</address> </p> </small>

<p align=right><small><i>Last Modified: 4/16/96</i></small></p>

</body>
</html>
